<?
/*
 * This file is part of the YateAdmin Project http://yateadmin.null.ro
 * A free web interface to set up a server based on the Yate telephony engine.
 * Copyright (C) 2006 Null Team
 *
 * Yet Another Telephony Engine - a fully featured software PBX and IVR
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
 */
?>

<?

/*
//cdr
 */

$val = getparam('val');
if (!$val)
	$val=0;
$total = getparam('total');
$option = getparam('option');
$client = getparam('client');
$call_nr = getparam('call_nr');
$direction = getparam('direction');
$bday =  getparam("begin_day");
$bmonth = getparam("begin_month");
$byear = getparam("begin_year");
$eday = getparam("end_day");
$emonth = getparam("end_month");
$eyear = getparam("end_year");
$bhour = getparam("begin_hour");
$ehour = getparam("end_hour");
$btime = getparam('btime');
$etime = getparam('etime');

$query="SELECT line FROM lines ORDER BY line";
$res=pg_exec($conn,$query);
if (!$res)
	die("Failed selecting line from lines");

loadbanner("Call Detailed Report");
?>

	<form action="main.php" method="post">
		<input type="hidden" name="module" value="cdr"/>
		<br><br>
		View call detailed report for:<br><br>
		<input type="radio" name="option" value="1" <? if ($option=="1") print ('CHECKED');?> />
				Select line:
				<select name="client" size="1">
					<?
					for($i=0;$i<pg_num_rows($res);$i++)
		{ ?>
					<option <?if ($client==pg_fetch_result($res,$i,0)) print ('SELECTED');?> > <? print pg_fetch_result($res,$i,0); ?> </option>
					<? } ?>
				</select><br/>
		<input type="radio" name="option" value="2" <? if ($option=="2") print ('CHECKED'); ?> /> All lines
		<br/><br/>
		Limit to <input type="text" name="call_nr" value="<? print ($call_nr); ?>" size="4"/> calls<br/><br/>

	    From date:
		Day <input type="integer" name="begin_day" value="<? print ($bday);?>" size="2"/>
		Month <input type="text" name="begin_month" value="<? print ($bmonth); ?>" size="2"/>
		Year <input type="text" name="begin_year" value="<? print ($byear); ?>" size="4"/>
		-Hour <input type="text" name="begin_hour" value="<? print ($bhour);?>" size="2"/><br/><br/>

		To date:
		Day <input type="text" name="end_day" value="<?print ($eday);?>" size="2"/>
		Month <input type="text" name="end_month" value="<?print ($emonth); ?>" size="2"/>
		Year <input type="text" name="end_year" value="<?print ($eyear); ?>" size="4"/>
		-Hour <input type="text" name="end_hour" value="<?print ($ehour); ?>" size="2"/><br/><br/>

		<input type="submit" value="Send"/>
	</form>

<?

if ($option=="2")
{
if (!$btime) {
	$btime=dateCheck($byear,$bmonth,$bday,$bhour,0);
	if ($btime === false)
		die ("Wrong begin date");
	if ($btime === true)
		$btime=NULL;
	else
		$btime=" AND time>'$btime'";
}
if (!$etime) {
	$etime=dateCheck($eyear,$emonth,$eday,$ehour,59);
	if ($etime === false)
		die ("Wrong end time");
	if ($etime === true)
		$etime=NULL;
	else
		$etime=" AND time<'$etime'";
}

$save=$call_nr;

if ((($call_nr-$val) < 10) && ($call_nr)) {
	$lim = $call_nr-$val;
	if ($val==0)
		$total = 9;
} else {
	$lim = 10;
	if(!$total) {
		if ($call_nr!="")
			$call_nr="LIMIT $call_nr";
		$query="SELECT count(*) FROM cdr WHERE direction='outgoing' $btime $etime $call_nr";
		$res = pg_exec($conn,$query);
		$total = pg_fetch_result($res,0,0);
	}
}

$query="SELECT date_trunc('sec',time), address,caller, called, date_trunc('sec',duration), date_trunc('sec',billtime), date_trunc('sec',ringtime), status,reason FROM cdr WHERE direction='outgoing' $btime $etime  ORDER BY time DESC LIMIT $lim OFFSET $val";

$res=pg_exec($conn,$query);

if (!$res)
	die("Failed selecting information from cdr");

?>
	<table class="content">
		<tr>
			<th class="content">Time</th>
			<th class="content">Address</th>
			<th class="content">Caller</th>
			<th class="content">Called</th>
			<th class="content">Duration</th>
			<th class="content">Billtime</th>
			<th class="content">Ringtime</th>
			<th class="content">Status</th>
			<th class="content">Reason</th>
		</tr>
<?

for($i=0; $i<pg_num_rows($res); $i++)
{ ?>
		<tr>
		<? for($j=0;$j<pg_num_fields($res);$j++) { ?>
			<td class="content"> <? print pg_fetch_result($res,$i,$j); ?> </td>
		<? } ?>
		</tr>
<? }
?></table><?

$params["val"]=$val;
$params["module"]="cdr";
$params["option"]=$option;
$params["call_nr"]=$save;
$params["total"]=$total;
$params["tot"]=$total;
$params["btime"]=$btime;
$params["etime"]=$etime;
navbuttons($params);

}

if ($option=="1")
{
	if (!$btime) {
		$btime=dateCheck($byear,$bmonth,$bday,$bhour,0);
		if ($btime === false)
			die ("Wrong begin date");
		if ($btime === true)
			$btime=NULL;
		else
			$btime=" AND time>'$btime'";
	}
	if (!$etime) {
		$etime=dateCheck($eyear,$emonth,$eday,$ehour,59);
		if ($etime === false)
			die ("Wrong end time");
		if ($etime === true)
			$etime=NULL;
		else
			$etime=" AND time<'$etime'";
	}

	$save=$call_nr;

	if ((($call_nr-$val) < 10) && ($call_nr)) {
		$lim = $call_nr-$val;
		if ($val==0)
			$total = 9;
	} else {
		$lim = 10;
		if(!$total) {
			if ($call_nr!="")
				$call_nr="LIMIT $call_nr";
			$query = "SELECT count(*) FROM cdr WHERE direction='outgoing' AND caller='$client' $btime $etime OR direction='outgoing' AND called='$client' $btime $etime  $call_nr";
			$res = pg_exec($conn,$query);
			$total = pg_fetch_result($res,0,0);
		}
	}

	$query="SELECT date_trunc('sec',time), address, caller, called, date_trunc('sec',duration), date_trunc('sec',billtime), date_trunc('sec',ringtime), status,reason FROM cdr WHERE direction='outgoing' AND caller='$client' $btime $etime OR direction='outgoing' AND called='$client' $btime $etime ORDER BY time DESC LIMIT $lim OFFSET $val";
	$res=pg_exec($conn,$query);

	if (!$res)
		die("Failed selecting information from cdr");
?>
	<table class="content">
		<tr>
			<th class="content">Time</th>
			<th class="content">Address</th>
			<th class="content">Caller</th>
			<th class="content">Called</th>
			<th class="content">Duration</th>
			<th class="content">Billtime</th>
			<th class="content">Ringtime</th>
			<th class="content">Status</th>
			<th class="content">Reason</th>
		</tr>
<? for($i=0; $i<pg_num_rows($res); $i++)
{ ?>
		<tr>
		<? for($j=0;$j<pg_num_fields($res);$j++) { ?>
			<td class="content"> <? print pg_fetch_result($res,$i,$j); ?> </td>
		<? } ?>
		</tr>
<? }
?>	</table>
<?
$params["val"]=$val;
$params["module"]="cdr";
$params["option"]=$option;
$params["call_nr"]=$save;
$params["total"]=$total;
$params["tot"]=$total;
$params["btime"]=$btime;
$params["etime"]=$etime;
$params["client"]=$client;
navbuttons($params);

}
/* vi: set ts=8 sw=4 sts=4 noet: */
?>
