<?
/*
 * This file is part of the YateAdmin Project http://yateadmin.null.ro
 * A free web interface to set up a server based on the Yate telephony engine.
 * Copyright (C) 2006 Null Team
 *
 * Yet Another Telephony Engine - a fully featured software PBX and IVR
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
 */
?>

<?
/*
//YateAccounts module
*/



loadbanner("Yate Accounts");
$val = getparam('val');
if (!$val)
	$val=0;
$id = getparam('id');
$protocol = getparam('protocol');

switch($method) {
	case "findel":
		findel($id);
		break;
	case "finedit":
		finedit($id);
		break;
	case "delete":
		del($id);
		break;
	case "edit":
		edit($id);
		break;
}

if ($method=="findel" || $method=="finedit" || !$method ) {
?>
<br/>
<form action="main.php" method="post">
	<input type="hidden" name="module" value="yateAccounts"/>
	<input type="hidden" name="method" value="edit"/>
	New account for protocol
	<select name="id">
		<option> sip </option>
		<option> h323 </option>
		<option> iax </option>
	</select>
	<input type="submit" value="Add"/>
</form>
<br/>
<table class="content">
	<tr class="content">
		<th class="content"> Account </th>
		<th class="content"> Server </th>
		<th class="content"> Protocol </th>
		<th class="content" colspan="2"> Options </th>
		<th class="content"> Status <th>
	</tr>
<?
$query = "SELECT count(*) FROM accounts ";
$res = pg_exec($conn,$query);
$total = pg_fetch_result($res,0,0);

$query = "SELECT account,server,registrar,gatekeeper,protocol,status,id FROM accounts ORDER BY protocol,account LIMIT 10 OFFSET $val";
$res = pg_exec($conn,$query);
for( $i=0; $i<pg_num_rows($res); $i++) {
	$id = pg_fetch_result($res,$i,6);
	$protocol = pg_fetch_result($res,$i,4);
	?>
	<tr class="content">
		<td class="content"> &nbsp;<? print pg_fetch_result($res,$i,0);?> </td>
		<td class="content"> &nbsp;<?
			switch($protocol) {
				case "sip":
					print pg_fetch_result($res,$i,2);
					break;
				case "h323":
					print pg_fetch_result($res,$i,3);
					break;
				case "iax":
					print pg_fetch_result($res,$i,1);
				break;
			}
		?> </td>
		<td class="content"> &nbsp;<? print $protocol; ?> </td>
		<td class="content"> <a href="main.php?module=yateAccounts&method=edit&id=<? print $id;?>"> Edit </a> </td>
		<td class="content"> <a href="main.php?module=yateAccounts&method=delete&id=<? print $id;?>"> Delete </a> </td>
		<td class="content"> &nbsp;<? print pg_fetch_result($res,$i,5); ?> </td>
	</tr>
<? } ?>
</table>
<?
$params["module"] = "yateAccounts";
$params["val"] = $val;
$params["tot"] = $total;
navbuttons($params);
}

function del($id)
{
	global $conn,$val;
	$query = "SELECT account,protocol FROM accounts WHERE id=$id";
	$res = pg_exec($conn,$query);
	$protocol = pg_fetch_result($res,0,1);
	$account = pg_fetch_result($res,0,0);
?> </br><br/> <?
	print (" Are you sure you want to delete $protocol account $account?");
?>
<br/><br/>
<table>
	<tr>
		<td>
			<form action="main.php" method="post">
				<input type="hidden" name="module" value="yateAccounts"/>
				<input type="hidden" name="method" value="findel"/>
				<input type="hidden" name="id" value="<? print $id;?>"/>
				<input type="hidden" name="val" value="<? print $val;?>"/>
				<input type="submit" value="Yes"/>
			</form>
		</td>
		<td>
			<form action="main.php?" method="post">
				<input type="hidden" name="module" value="yateAccounts"/>
				<input type="hidden" name="val" value="<? print $val;?>"/>
				<input type="submit" value=" No "/>
			</form>
		</td>
	</tr>
</table>
<?
}

function findel($id)
{
	global $conn;
	$query = "DELETE FROM accounts WHERE id=$id";
	$res = pg_exec($conn,$query);
	if (!pg_affected_rows($res))
		print ("Error at deleting account");
}

function edit($id)
{
	global $conn;
	
	switch ($id) {
		case "sip": {
			$query = "SELECT 'sip' as protocol,NULL AS account,NULL AS username,NULL AS authname,NULL AS password, NULL AS registrar,NULL AS outbound,NULL AS domain,NULL AS localaddress,NULL AS description,NULL AS interval, NULL AS formats,NULL AS number,FALSE AS modified,FALSE AS enabled";
			break;	
		}
		case "h323": {
			$query = "SELECT 'h323' as protocol,NULL AS account,NULL AS username,NULL AS password,NULL AS gatekeeper, NULL AS description,NULL AS interval,NULL AS formats,NULL AS number,FALSE AS modified,FALSE AS enabled ";
			break;
		}
		case "iax": {
			$query = "SELECT 'iax' AS protocol,NULL AS account,NULL AS username,NULL AS password,NULL AS server, NULL AS description,NULL AS interval,NULL AS formats,NULL AS number,FALSE AS modified,FALSE AS enabled";
			break;
		}
		default: {
			$query = "SELECT protocol FROM accounts WHERE id=$id";
			$res = pg_exec($conn,$query);
			switch(pg_fetch_result($res,0,0))
			{
			case "sip":
					$query = "SELECT protocol, account, username, authname, password, registrar, outbound, domain,localaddress, description, interval, formats, number, modified, enabled  FROM accounts WHERE id=$id";
					break;
			case "h323":
					$query = "SELECT protocol, account, username, password, gatekeeper, description, interval, formats, number, modified, enabled  FROM accounts WHERE id=$id";
					break;
			case "iax":
					$query = "SELECT protocol, account, username, password, server, description, interval, formats, number, modified, enabled  FROM accounts WHERE id=$id";
					break;
			}
		}
	}
	makeedit($id,$query);
}



function makeedit($id,$query)
{
	global $conn,$val;
	$res = pg_exec($conn,$query);
?>
<br/>

<form action="main.php" method="post">
	<input type="hidden" name="module" value="yateAccounts"/>
	<input type="hidden" name="method" value="finedit"/>
	<input type="hidden" name="id" value="<? print $id; ?>"/>
	<input type="hidden" name="val" value="<? print $val;?>"/>
	<table class="vertical">
<? for($i=0 ; $i < pg_num_fields($res); $i++) { ?>
		<tr class="vertical">
			<th class="vertical"> <?$fieldname =  pg_field_name($res,$i); print $fieldname; ?> </th>
		<?	if ($fieldname=="protocol") {
				?> <td class="vertical"> <? print pg_fetch_result($res,0,$i); ?> </td> <?
				continue;
}
			if ($fieldname != "enabled" && $fieldname != "modified")  { ?>
				<td class="vertical"> <input type="text" name="<? print pg_field_name($res,$i);?>" value="<? print pg_fetch_result($res,0,$i);?>" size="10"/> </td>
		<? } else { ?>
				<td class="vertical"> <input type="checkbox" name="<? print pg_field_name($res,$i)?>" <? if (pg_fetch_result($res,0,$i)=='t') print ("CHECKED"); ?>/> </td>
		<? } ?>
		</tr>
<? } ?>
	</table>
	<br/>
	<table>
		<tr>
			<td> <input type="submit" value="Save"/> </td>
			<td><input type="reset" value="Clear"/></td>
		</tr>
	</table>
</form>

<?
}

function verifynull($param)
{
	$param = getparam("$param");
	if($param)
		$param = "'$param'";
	else
		$param = 'NULL';
	return $param;
}

function finedit($id)
{
	global $conn,$path;
	$account = getparam('account');

	$modified = getparam('modified');
	$enabled = getparam('enabled');

	if($account)
	{	$query = "SELECT id FROM accounts WHERE account='$account'";
		$res = pg_exec($conn,$query);
		if ($res && pg_num_rows($res)) {
			$fid = pg_fetch_result($res,0,0);

			if (((pg_num_rows($res)>1) || (pg_num_rows($res)==1 && $id!=$fid))) {
				print ("This account is already used. Accounts must be unique");
				return;
			}
		}
	}

	if(!getparam('username') || !getparam('account') || !(getparam('registrar') || getparam('server') || getparam('gatekeeper'))) {
		print ('Username,account and (server or registrar or gatekeeper) must be defined.');
		return;
	}
	
	if ($id == "sip" || $id == "h323" || $id == "iax") {
		$username = getparam("username");
		$registrar = verifynull("registrar");
		$description = verifynull("description");
		$interval = verifynull("interval");
		$formats = verifynull("formats");
		$password = verifynull("password");
		$server = verifynull("server");
		$gatekeeper = verifynull("gatekeeper");
		$authname = verifynull("authname");
		$domain = verifynull("domain");
		$localaddress = verifynull("localaddress");
		$number = verifynull("number");
		if ($enabled=="on")
			$enabled='t';
		else
			$enabled='f';
		if ($modified=="on")
			$modified='t';
		else
			$modified='f';	
		$query = "INSERT INTO accounts(protocol,account, username, description, interval, formats, password, server, gatekeeper, authname, domain, localaddress, registrar, number, modified, enabled) VALUES('$id','$account', '$username', $description, $interval, $formats, $password, $server, $gatekeeper, $authname, $domain, $localaddress, $registrar , $number,'$modified','$enabled')";
		$res = pg_exec($conn,$query);
		if (!pg_affected_rows($res)) {
			print ("Error at adding account");
			return;
		}
		return;
	}

	$account = verifyparam("account",getparam('account'),0);
	$username= verifyparam("username",getparam('username'),0);
	$description = verifyparam("description",getparam('description'),0);
	$interval = verifyparam("interval" ,getparam('interval'),0);
	$formats = verifyparam("formats",getparam('formats'),0);
	$password =  verifyparam("password",getparam('password'),0);
	$server = verifyparam("server",  getparam('server'),0);
	$gatekeeper = verifyparam("gatekeeper", getparam('gatekeeper'),0);
	$registrar = verifyparam("registrar", getparam('registrar'),0);
	$authname = verifyparam("authname",getparam('authname'),0);
	$domain =  verifyparam("domain",getparam('domain'),0);
	$outbound = verifyparam("outbound",getparam('outbound'),0);
	$localaddress = verifyparam("localaddress",getparam('localaddress'),0);
	$number = verifyparam("number",getparam('number'),0);
	if ($modified=="on")
		$modified = "modified='t'";
	else
		$modified = "modified='f'";

	if ($enabled=="on")
		$enabled = "enabled='t'";
	else
		$enabled = "enabled='f'";
	$query = "UPDATE accounts SET $modified , $enabled $account $localaddress $outbound $domain $authname $registrar $gatekeeper $server $password $formats $interval $description $username $number WHERE id=$id";
	$res = pg_exec($conn,$query);
	if (!pg_affected_rows($res))
		print ("Error at updating account");
}

/* vi: set ts=8 sw=4 sts=4 noet: */
?>
