<?
/*
 * This file is part of the YateAdmin Project http://yateadmin.null.ro
 * A free web interface to set up a server based on the Yate telephony engine.
 * Copyright (C) 2006 Null Team
 *
 * Yet Another Telephony Engine - a fully featured software PBX and IVR
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
 */
?>

<?
/*
//Accounts module
*/


$customer = getparam('customer');
$user = getparam('username');


loadbanner("Accounts");

if ($method == "finedit")
{
	finedit($user);
	$method=NULL;
}


if ($method)
{
	switch ($method)
	{
	case "add":
		add($user);
		break;
	case "edit":
		edit($user);
		break;
	case "delete":
		del($user);
		break;
	}
} else {
	$query = "SELECT username,first,last,description from users ORDER BY username";
	$res = pg_query($conn,$query);

    ?>
	<form action="main.php" method="post"><br/>
		<input type="hidden" name="module" value="accounts"/>
		<input type="hidden" name="method" value="add"/>
		Add new username <input type="text" name="username" size="8"/>
		<input type="submit" value="Add"/>
	</form>
	<br/>
	<table class="content">
		<tr>
			<th class="content">&nbsp;Username&nbsp;</th>
			<th class="content">&nbsp;First name&nbsp;</th>
			<th class="content">&nbsp;Last name&nbsp;</th>
			<th class="content" colspan="3">&nbsp;Description&nbsp;&nbsp;&nbsp;</th>
		</tr>
	<? for($i=0;$i<pg_num_rows($res);$i++)
	{
	?>
		<tr>
			<td class="content"> &nbsp;<? print pg_fetch_result($res,$i,0);?> </td>
			<td class="content"> &nbsp;<? print pg_fetch_result($res,$i,1);?> </td>
			<td class="content"> &nbsp;<? print pg_fetch_result($res,$i,2);?> </td>
			<td class="content"> &nbsp;<? print pg_fetch_result($res,$i,3);?> </td>
			<td class="content"><a href="main.php?module=accounts&method=edit&username=<? print pg_fetch_result($res,$i,0); ?>">Edit</a> </td>
			<td class="content"><a href="main.php?module=accounts&method=delete&username=<? print pg_fetch_result($res,$i,0); ?>">Delete</a> </td>
		</tr>
	<? } ?>
		</table>
    <?
}

function add ($username)
{
	global $conn,$path;
	$query = "SELECT username FROM users WHERE username='$username' ";
	$res = pg_query($conn,$query);
	if (pg_num_rows($res) > 0) {
		message("User $username already exists!",$path);
		return;
	}
	$query = "INSERT INTO users (username) VALUES ('$username');";
	$res = pg_query($conn,$query);
	if ($res)
	{
		edit($username);
		return;
	}
	message ("I was unable to add new user $username",$path);
}

function edit ($username)
{
	global $conn,$path;
	$query = "SELECT first,last,password,description FROM users WHERE username='$username'";
	$res = pg_query($conn,$query);
	if(!$res)
		die("Failed to select information from users");

?>
		<br/>
		<form action="main.php">
			<input type="hidden" name="module" value="accounts"/>
			<input type="hidden" name="method" value="finedit"/>
			<input type="hidden" name="username" value="<? print $username;?>"/>
			<table class="vertical">
				<tr>
					<th class="vertical"> Username </th>
					<td class="vertical"> &nbsp;<? print $username;?> </td>
				</tr>
				<tr>
					<th class="vertical">Password</th>
					<td class="vertical"><input type="text" name="password" value="<? print pg_fetch_result($res,0,2);?>" size="8"/></td>
				</tr>
				<tr>
					<th class="vertical">&nbsp;First name&nbsp;</th>
					<td class="vertical"><input type="text" name="first" value="<? print pg_fetch_result($res,0,0);?>" size="8"/></td>
				</tr>
				<tr>
					<th class="vertical">Last name</th>
					<td class="vertical"><input type="text" name="last" value="<? print pg_fetch_result($res,0,1);?>" size="8"/></td>
				</tr>
				<tr>
					<th class="vertical">Description</th>
					<td class="vertical"><input type="text" name="description" value="<? print pg_fetch_result($res,0,3);?>" size="8" /> </td>
				</tr>
			</table>
			<br/>
			<table>
				<tr>
					<td>
						<input type="submit"  value="Save"/>
					</td>
					<td>
						<input type="reset" value="Clear"/>
					</td>
				</tr>
			</table>
		</form>
<?
}

function finedit ($username)
{
    global $conn;
	$firstname = verifyparam("first",getparam('first'),1);
	$lastname = verifyparam("last",getparam('last'),0);
	$description = verifyparam("description",getparam('description'),0);
	$password = verifyparam("password",getparam('password'),0);
	if ($username)
		$query = "UPDATE users set $firstname $lastname $password $description WHERE username='$username'";
        $res = pg_query($conn,$query);
        if (!pg_affected_rows($res))
        	print ("Error at updating username $username");
}


function del ($username)
{
        global $conn;
		global $path;
        $query = "DELETE FROM users WHERE username='$username'";
        $res = pg_query($conn,$query);
        if ($res && (pg_affected_rows($res) == 1)) {
                message("Deleted user $username",$path);
                return;
		}
        else {
                message("Unable to delete user $username",$path);
                return;
		}
}

?>
