<?
/*
 * This file is part of the YateAdmin Project http://yateadmin.null.ro
 * A free web interface to set up a server based on the Yate telephony engine.
 * Copyright (C) 2006 Null Team
 *
 * Yet Another Telephony Engine - a fully featured software PBX and IVR
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
 */
?>

<?
/*
** route module(setting routes)
*/
loadbanner("Defining routes");
$val = getparam('val');
if (!$val)
	$val=0;
$id = getparam('id');
$protocol = getparam('protocol');
$route_for_account = getparam('route_for_account');
$newroute = getparam('newroute');

switch($method) {
	case "finedit":
		finedit($id);
		break;
	case "findel":
		findel($id);
		break;
	case "edit":
		edit($id,$newroute,$protocol);
		break;
	case "delete":
		del($id);
		break;
	case "rewrite":
		rewrite($id);
		break;
}

if ($method == "finedit" || $method == "findel" || $method == "addacc" || !$method)
{
?>
<br/>
<form action="main.php" method="post">
	<input type="hidden" name="module" value="routes"/>
	<input type="hidden" name="method" value="edit"/>
	<input type="hidden" name="val" value="<? print $val;?>"/>
	<input type="hidden" name="newroute" value="new"/>
	Select protocol to add new protocol
	<select name="protocol">
		<option> sip </option>
		<option> h323 </option>
		<option> iax </option>
		<option> wp </option>
		<option> zap </option>
	</select>
	<br/>
	OR
	<br/>
	Check to add route for account <input type="checkbox" name="route_for_account">
	<br/><br/>
	<input type="submit" value="Add"/>
</form>

<br/>
<table class="content">
	<tr class="content">
		<th class="content"> Priority </th>
		<th class="content"> Protocol </th>
		<th class="content"> Prefix </th>
		<th class="content"> IP </th>
		<th class="content"> Chans/Group </th>
		<th class="content"> Account </th>
		<th class="content" colspan="3"> Options </th>
	</tr>
<?
$query = "SELECT count(*) FROM routes ";
$res = pg_exec($conn,$query);
$total = pg_fetch_result($res,0,0);;

$query = "SELECT priority,protocol,prefix,ip,chan_group,id,account FROM routes ORDER BY prefix,priority LIMIT 10 OFFSET $val";
$res = pg_exec($conn,$query);

for($i=0 ;$i<pg_num_rows($res);  $i++) {
	$id = pg_fetch_result($res,$i,5);

?>
	<tr class="content">
		<td class="content"> &nbsp;<? print pg_fetch_result($res,$i,0);?> </td>
		<td class="content"> &nbsp;<? print pg_fetch_result($res,$i,1);?> </td>
		<td class="content"> &nbsp;<? print pg_fetch_result($res,$i,2);?> </td>
		<td class="content"> &nbsp;<? print pg_fetch_result($res,$i,3);?> </td>
		<td class="content"> &nbsp;<? print pg_fetch_result($res,$i,4);?> </td>
		<td class="content"> &nbsp;<? print pg_fetch_result($res,$i,6);?> </td>
		<td class="content"> <a href="main.php?module=routes&method=edit&id=<? print $id;?>&val=<? print $val;?>"> Edit </a> </td>
		<td class="content"> <a href="main.php?module=routes&method=delete&id=<? print $id;?>&val=<? print $val;?>"> Delete </a> </td>
		<td class="content"> <a href="main.php?module=routes&method=rewrite&id=<? print $id;?>&val=<? print $val;?>"> Rewrite </a> </td>

	</tr>
<? }
?>
</table>
<?

$params["module"] = "routes";
$params["val"] = $val;
$params["tot"] = $total;
navbuttons($params);
}

function del($id)
{
	global $conn;
	$query = "SELECT priority,protocol FROM routes WHERE id=$id";
	$res = pg_exec($conn,$query);
	$protocol = pg_fetch_result($res,0,1);
	$priority = pg_fetch_result($res,0,0);
?> <br/><br/> <?
	print (" Are you sure you want to delete $protocol route with priority $priority?");
?>
		<br/><br/>
<table>
	<tr>
		<td>
			<form action="main.php" method="post">
				<input type="hidden" name="module" value="routes"/>
				<input type="hidden" name="method" value="findel"/>
				<input type="hidden" name="id" value="<? print $id;?>"/>
				<input type="submit" value="Yes"/>
			</form>
		</td>
		<td>
			<form action="main.php?" method="post">
				<input type="hidden" name="module" value="routes"/>
				<input type="submit" value=" No "/>
			</form>
		</td>
	</tr>
</table>
<?
}

function findel($id) {
	global $conn;

	$query = "DELETE FROM routes WHERE id=$id";
	$res = pg_exec($conn,$query);
	if(!pg_affected_rows($res))
		print("Error at deleting route");
}

function edit($id,$newroute,$protocol) {
	global $conn,$route_for_account;

	if ($newroute) {
		if ($route_for_account=="on") {
			$protocol = "account";
			$id = NULL;
		}
		$id=NULL;
	}
	else {
		$query = "SELECT protocol,account FROM routes WHERE id=$id";
		$res = pg_exec($conn,$query);
		if (!$res) {
			print("Error at editing");
			return;
		}
		$protocol = pg_fetch_result($res,0,0);
		$acc = pg_fetch_result($res,0,1);
		if ($acc)
			$protocol = "account";
	}
	switch($protocol)
	{
		case "sip":
			editsiph323($id,$newroute,$protocol);
		break;
		case "h323":
			editsiph323($id,$newroute,$protocol);
		break;
		case "wp":
			editwpzap($id,$newroute,$protocol);
		break;
		case "zap":
			editwpzap($id,$newroute,$protocol);
		break;
 		case "iax":
			editiax($id,$newroute);
		break;
		case "account":
			editaccount($id,$newroute);
		break;
	}
}

function editaccount($id,$newroute)
{
	global $conn,$val;
?>
<br/>
<form action="main.php" method="post">
	<input type="hidden" name="module" value="routes"/>
	<input type="hidden" name="method" value="finedit"/>
	<input type="hidden" name="id" value="<? print $id;?>"/>
	<input type="hidden" name="val" value="<? print $val;?>"/>
	<input type="hidden" name="newroute" value="<? print $newroute;?>"/>
	<input type="hidden" name="isaccount" value="yes"/>
	<?
	if ($newroute)
		$query = "SELECT NULL as priority,NULL AS prefix, NULL AS protocol, NULL AS account";
	else
		$query = "SELECT priority,prefix,protocol,account FROM routes WHERE id='$id'";
	$res = pg_exec($conn,$query);

	$priority = pg_fetch_result($res,0,0);
	$prefix = pg_fetch_result($res,0,1);
	$protocol = pg_fetch_result($res,0,2);
	$account = pg_fetch_result($res,0,3);

?>
	<table class="vertical">
		<tr>
			<th class="vertical"> Priority </th>
			<td class="vertical"> <input type="text" name="priority" value="<? print $priority;?>" size="8"/></td>
		</tr>
		<tr>
			<th class="vertical"> &nbsp; Protocol &nbsp;</th>
			<td class="vertical"> <? print $protocol;?></td>
		</tr>
		<tr>
			<th class="vertical"> Prefix </th>
			<td class="vertical"> <input type="text" name="prefix" value="<? print $prefix;?>" size="8"/> </td>
		</tr>
		<tr>
			<th class="vertical"> Check to match everything </th>
			<td class="vertical"> <input type="checkbox" name="clearprefix" <? if ((!$prefix || $prefix='')&&(!$newroute)) print("CHECKED");?>/></td>
		</tr>
		<tr>
			<th class="vertical"> Account </th>
			<td class="vertical">
				<select name="account">
					<? $query ="SELECT account FROM accounts WHERE account IS NOT NULL";
						$res2 = pg_exec($conn,$query);
						for($i=0;$i<pg_num_rows($res2);$i++)
						{
							$acc = pg_fetch_result($res2,$i,0);
							?> <option <? if ($acc==$account) print ("SELECTED");?>> <? print $acc; ?> </option>
					 <? } ?>
				</select>
			</td>
		</tr>
	</table>
	<br/>
	<table>
		<tr>
			<td> <input type="submit" value="Save"/> </td>
			<td> <input type="reset" value="Clear"/> </td>
		</tr>
	</table>
	<input type="hidden" name="protocol" value="<? print pg_fetch_result($res,0,2);?>"/>
</form>
<?
}

function editiax($id,$newroute)
{
	global $conn,$val;
?>
<br/>
<form action="main.php" method="post">
	<input type="hidden" name="module" value="routes"/>
	<input type="hidden" name="method" value="finedit"/>
	<input type="hidden" name="id" value="<? print $id;?>"/>
	<input type="hidden" name="val" value="<? print $val;?>"/>
	<input type="hidden" name="newroute" value="<? print $newroute;?>"/>
	<?
	if ($newroute)
		$query = "SELECT NULL as priority,NULL AS prefix,'iax' AS protocol,NULL AS ip, 4569 AS port, NULL AS iaxuser, NULL AS iaxcontext";
	else
		$query = "SELECT priority,prefix,protocol,ip,port,iaxuser,iaxcontext FROM routes WHERE id=$id";
	$res = pg_exec($conn,$query);
	?>
	<table class="vertical">
		<tr>
			<th class="vertical"> Priority </th>
			<td class="vertical"> <input type="text" name="priority" value="<? print pg_fetch_result($res,0,0);?>" size="14"/></td>
		</tr>
		<tr>
			<th class="vertical"> &nbsp; Protocol &nbsp;</th>
			<td class="vertical"> <? print pg_fetch_result($res,0,2);?></td>
		</tr>
		<tr>
			<th class="vertical"> Prefix </th>
			<td class="vertical"> <input type="text" name="prefix" value="<? $prefix=pg_fetch_result($res,0,1); print $prefix;?>" size="14"/> </td>
		</tr>
		<tr>
			<th class="vertical"> Check to match everything </th>
			<td class="vertical"> <input type="checkbox" name="clearprefix" <? if ((!$prefix || $prefix='')&&(!$newroute)) print("CHECKED");?>/></td>
		</tr>
		<tr>
			<th class="vertical"> IP </th>
			<td class="vertical"> <input type="text" name="ip" value="<? print pg_fetch_result($res,0,3);?>" size="14"/> </td>
		</tr>
		<tr>
			<th class="vertical"> Port </th>
			<td class="vertical"> <input type="text" name="port" value="<? print pg_fetch_result($res,0,4);?>" size="14"/> </td>
		</tr>
		<tr>
			<th class="vertical"> IAXuser </th>
			<td class="vertical"> <input type="text" name="iaxuser" value="<? print pg_fetch_result($res,0,5);?>" size="14"/> </td>
		</tr>
		<tr>
			<th class="vertical"> IAXcontext</th>
			<td class="vertical"> <input type="text" name="iaxcontext" value="<? print pg_fetch_result($res,0,6);?>" size="14"/></td>
		</tr>
	</table>
	<br/>
	<table>
		<tr>
			<td> <input type="submit" value="Save"/> </td>
			<td> <input type="reset" value="Clear"/> </td>
		</tr>
	</table>
	<input type="hidden" name="protocol" value="<? print pg_fetch_result($res,0,2);?>"/>
</form>
<?
}

function editwpzap($id,$newroute,$protocol)
{
	global $conn,$val;
?>
</br>
<form action="main.php" method="post">
	<input type="hidden" name="module" value="routes"/>
	<input type="hidden" name="method" value="finedit"/>
	<input type="hidden" name="id" value="<? print $id;?>"/>
	<input type="hidden" name="val" value="<? print $val;?>"/>
	<input type="hidden" name="newroute" value="<? print $newroute;?>"/>
	<?
	if ($newroute)
		$query = "SELECT NULL AS priority, NULL AS prefix, '$protocol' AS protocol, NULL AS chan_group";
	else
		$query = "SELECT priority,prefix,protocol,chan_group FROM routes WHERE id=$id";
	$res = pg_exec($conn,$query);
	?>
	<table class="vertical">
		<tr>
			<th class="vertical"> Priority </th>
			<td class="vertical"> <input type="text" name="priority" value="<? print pg_fetch_result($res,0,0);?>" size="5"/>
		</tr>
		<tr>
			<th class="vertical"> Protocol </th>
			<td class="vertical"> <? print pg_fetch_result($res,0,2);?></td>
		</tr>
		<tr>
			<th class="vertical"> Prefix </th>
			<td class="vertical"> <input type="text" name="prefix" value="<? $prefix= pg_fetch_result($res,0,1); print $prefix;?>" size="5" /></td>
		</tr>
		<tr>
			<th class="vertical"> Check to match everything </th>
			<td class="vertical"> <input type="checkbox" name="clearprefix" <? if ((!$prefix || $prefix='')&&(!$newroute)) print("CHECKED");?>/></td>
		</tr>
		<tr>
			<th class="vertical"> &nbsp;Chans/Group&nbsp; </th>
			<td class="vertical"> <input type="text" name="channels" value="<? print pg_fetch_result($res,0,3);?>" size="5" /></td>
		</tr>
	</table>
	<br/>
	<table>
		<tr>
			<td> <input type="submit" value="Save"/> </td>
			<td> <input type="reset" value="Clear"/> </td>
		</tr>
	</table>
	<input type="hidden" name="protocol" value="<? print pg_fetch_result($res,0,2);?>"/>
</form>
<?
}

function editsiph323($id,$newroute,$protocol)
{
	global $conn,$val;
?>
<form action="main.php" method="post">
	<input type="hidden" name="module" value="routes"/>
	<input type="hidden" name="method" value="finedit"/>
	<input type="hidden" name="id" value="<? print $id;?>"/>
	<input type="hidden" name="val" value="<? print $val?>"/>
	<input type="hidden" name="newroute" value="<? print $newroute;?>"/>
	<?
	if ($newroute)
		$query = "SELECT NULL AS priority,NULL AS prefix, '$protocol' AS protocol, NULL AS ip, NULL AS port";
	ELSE
		$query = "SELECT priority,prefix,protocol,ip,port FROM routes WHERE id=$id";
	$res = pg_exec($conn,$query);

	?>
	<br/>
	<table class="vertical">
		<tr>
			<th class="vertical"> Priority </th>
			<td class="vertical"> <input type="text" name="priority" value="<? print pg_fetch_result($res,0,0);?>" size="14"/></td>
		</tr>
		<tr>
			<th class="vertical"> &nbsp; Protocol &nbsp;</th>
			<td class="vertical"> <? $proto = pg_fetch_result($res,0,2); print $proto;?></td>
		</tr>
		<tr>
			<th class="vertical"> Prefix </th>
			<td class="vertical"> <input type="text" name="prefix" value="<? $prefix=pg_fetch_result($res,0,1); print $prefix;?>" size="14"/> </td>
		</tr>
		<tr>
			<th class="vertical"> Check to match everything </th>
			<td class="vertical"> <input type="checkbox" name="clearprefix" <? if ((!$prefix || $prefix='')&&(!$newroute)) print("CHECKED");?>/></td>
		</tr>
		<tr>
			<th class="vertical"> IP </th>
			<td class="vertical"> <input type="text" name="ip" value="<? print pg_fetch_result($res,0,3);?>" size="14"/> </td>
		</tr>
		<tr>
			<th class="vertical"> Port </th>
			<td class="vertical"> <input type="text" name="port" value="
			<?
			$port = pg_fetch_result($res,0,4);
			if (!$port)
			    if ($proto == "sip")
				$port=5060;
			    else
				$port = 1720;
			 print $port;?>" size="14"/> </td>
		</tr>
	</table>
	<br/>
	<table>
		<tr>
			<td> <input type="submit" value="Save"/> </td>
			<td> <input type="reset" value="Clear"/> </td>
		</tr>
	</table>
	<input type="hidden" name="protocol" value="<? print pg_fetch_result($res,0,2);?>"/>
</form>
<?
}

function finedit($id)
{
	global $conn,$val,$path;
	$isaccount = getparam('isaccount');
	$protocol = getparam('protocol');
	$prefix = getparam('prefix');
	$clearprefix = getparam('clearprefix');
	if (!$prefix || $clearprefix=="on")
		$prefix='';
	$priority = getparam('priority');
	if (!$priority) {
		message("Priority is not defined. Operation was canceled",$path);
		return;
	}
	$ip = getparam('ip');
	if (!$ip && $protocol!="wp" && $protocol!="zap" && $protocol && !$isaccount) {
		message("Ip is not defined. Operation was canceled",$path);
		return;
	}
	$port = getparam('port');
	if (!$port)
		$port='';
	$iaxuser = getparam('iaxuser');
	if (!$iaxuser)
		$iaxuser = 'a';
	$iaxcontext = getparam('iaxcontext');
	if (!$iaxcontext)
		$iaxcontext = '';
	$channels = getparam('channels');
	if (!$channels)
		$channels = '';
	$account=getparam('account');
	if (!$account)
		$account = '';

	if($priority && $priority!='')
	{	$query = "SELECT id FROM routes WHERE priority=$priority";
		$res = pg_exec($conn,$query);
		if ($res && pg_num_rows($res)) {
			$fid = pg_fetch_result($res,0,0);

			if (((pg_num_rows($res)>1) || (pg_num_rows($res)==1 && $id!=$fid))) {
				print ("This priority is already used");
				return;
			}
		}
	}
	if (($priority > 32000) || ($priority <0) )
	{
		message("The priority is too low or too high",$path);
		die();
	}

	$newroute = getparam("newroute");
	if ($newroute) {
		if ($account) {
			$query = "SELECT protocol FROM accounts WHERE account='$account'";
			$res = pg_exec($conn,$query);
			if(!pg_num_rows($res)) {
				message ("Error at adding new route",$path);
				return;
			} else
				$protocol = pg_fetch_result($res,0,0);
		} else
			$protocol = getparam('protocol');
		$query = "INSERT INTO routes(priority, protocol, prefix, ip, port, iaxuser, iaxcontext, chan_group, account, cutbool, replacebool) VALUES($priority,'$protocol','$prefix','$ip','$port','$iaxuser','$iaxcontext', '$channels', '$account', false, false)";
		$res = pg_exec($conn,$query);
		if (!pg_affected_rows($res))
			print ("Error at adding new route");
	} else {
		$query = "UPDATE routes SET prefix='$prefix' , priority=$priority , ip='$ip' , port='$port' , iaxuser='$iaxuser', iaxcontext='$iaxcontext', chan_group='$channels' ,account='$account' WHERE id=$id";
		$res = pg_exec($conn,$query);

		if (!pg_affected_rows($res))
			print("Error at updating route");
	}
}

function rewrite($id)
{
	global $val,$conn,$path;
	$flag = getparam('flag');

	$query = "SELECT cutbool,nrdigcut,poscut,replacebool,posrpl,digrpl,nrdigrpl,protocol,priority  FROM routes WHERE id=$id";
	$res = pg_exec($conn,$query);
	$protocol = pg_fetch_result($res,0,7);
	$priority = pg_fetch_result($res,0,8);
	if (!$flag) {
		?>
		<br/>
		Editing rewriting preferences for <? print $protocol;?> route with priority <? print $priority;?>
		<br/></br>
		<form action="main.php" method="post">
			<input type="hidden" name="module" value="routes"/>
			<input type="hidden" name="val" value="<? print $val;?>"/>
			<input type="hidden" name="method" value="rewrite"/>
			<input type="hidden" name="flag" value="flag"/>
			<input type="hidden" name="id" value="<? print $id;?>"/>
			<table class="vertical">
				<tr>
					<th class="vertical"> Cut digits </th>
					<td class="vertical"> <input type="checkbox" name="cutbool" <? if (pg_fetch_result($res,0,0)=='t') print ("CHECKED");?>/> </td>
				</tr>
				<tr>
					<th class="vertical"> Nr of digits to cut </th>
					<td class="vertical"> <input type="text" name="nrdigcut" value="<? print pg_fetch_result($res,0,1);?>" size="4"/></td>
				</tr>
				<tr>
					<th class="vertical"> Position to start cut </th>
					<td class="vertical"> <input type="text" name="poscut" value="<? print pg_fetch_result($res,0,2);?>" size="4"/></td>
				</tr>
				<tr>
					<th class="vertical"> Replace digits </th>
					<td class="vertical"> <input type="checkbox" name="replacebool" <? if (pg_fetch_result($res,0,3)=='t') print ("CHECKED");?>/> </td>
				</tr>
				<tr>
					<th class="vertical"> Position to start replace </th>
					<td class="vertical"> <input type="text" name="posrpl" value="<? print pg_fetch_result($res,0,4);?>" size="4"/></td>
				</tr>
				<tr>
					<th class="vertical"> Digits to replace with </th>
					<td class="vertical"> <input type="text" name="digrpl" value="<? print pg_fetch_result($res,0,5);?>" size="4"/></td>
				</tr>
				<tr>
					<th class="vertical"> Nr of digits to replace </th>
					<td class="vertical"> <input type="text" name="nrdigrpl" value="<? print pg_fetch_result($res,0,6);?>" size="4"/></td>
				</tr>
			</table>
			<br/>
			<input type="submit" value="Save"/>
		</form>
		<?
	} else {
		$cutbool = getparam('cutbool');
		$replacebool = getparam('replacebool');
		print getparam("digrpl");
		$digrpl = getparam('digrpl');
		if ($digrpl=="0" || $digrpl)
			$digrpl = ", digrpl='$digrpl'";
		else
			$digrpl = ", digrpl=NULL";
		$nrdigcut = verifyparam("nrdigcut",getparam('nrdigcut'),0);
		$poscut = verifyparam("poscut",getparam('poscut'),0);
		$posrpl = verifyparam("posrpl",getparam('posrpl'),0);
		$nrdigrpl = verifyparam("nrdigrpl",getparam('nrdigrpl'),0);

		if ($cutbool=="on")
			$cutbool="cutbool='t'";
		else
			$cutbool="cutbool='f'";

		if($replacebool=="on")
			$replacebool="replacebool='t'";
		else
			$replacebool="replacebool='f'";
		$query = "UPDATE routes SET $cutbool, $replacebool $nrdigcut $poscut $posrpl $digrpl $nrdigrpl WHERE id=$id";

		$res = pg_exec($conn,$query);
		if(pg_affected_rows($res))
			message("Updated route succesfully",$path);
		else
			message("Error at updating route",$path);
	}
}
/* vi: set ts=8 sw=4 sts=4 noet: */
?>
